<template>
  <div>
    <AppWindow
        v-bind:show="show"
        title="Create a new project"
        cancelable
        @canceled="() => this.$emit('canceled')"
        @submitted="createProjectBtnClick"
        :disabled-submit="disableCreateBtn"
    >
      <br>
      <v-text-field
          label="Project name"
          v-model="projectName"
          color="secondary"
          suffix=".siex"
          :rules="[required, counter, pattern]"
          counter
      ></v-text-field>

      <template v-slot:submit-text>
        Create
      </template>
    </AppWindow>
  </div>
</template>

<script>

import AppWindow from "./../AppWindow/AppWindow"
import {AppContext} from '@Util'

export default {
  name: 'CreateProject',
  components: {
    AppWindow
  },
  props: {
    show: Boolean
  },
  data: () => ({
    projectName: '',
    required: value => !!value || 'Required.',
    counter: value => value.length <= 20 || 'Max 20 characters',
    pattern: value => {
      const pattern = /^[a-zA-Z0-9-_]*$/
      return pattern.test(value) || 'Aplhanumerical characters only, accept "-" and "_"'
    },
  }),
  watch: {
    show(val) {
      Object.assign(AppContext, {mode: val ? 0 : 2})
    }
  },
  methods: {
    createProjectBtnClick() {
      if (this.required(this.projectName) === true
          && this.counter(this.projectName) === true
          && this.pattern(this.projectName) === true) {
        this.$emit('project', this.projectName + '.siex')
        this.projectName = ''
      }
    }
  },
  computed: {
    disableCreateBtn() {
      return !(this.required(this.projectName) === true
          && this.counter(this.projectName) === true
          && this.pattern(this.projectName) === true)
    }
  }
}
</script>